/* Problem URL: https://codeforces.com/contest/2149/problem/E */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n, k, l, r;
        cin >> n >> k >> l >> r;

        map<int, int> var;
        vi fds(n);
        repv(i, fds) {
            cin >> i;
            var[i] = 0;
        }

        int v = 0;
        repv(i, var) {
            i.second = v;
            v++;
        }

        repv(i, fds) {
            i = var[i];
        }

        vi elem1(v);
        vi elem2(v);

        int c1 = 0;
        int c2 = 0;

        auto add = [&](vi &elem, int i, int &c) {
            elem[i]++;
            if (elem[i] == 1) {
                c++;
            }
        };

        auto rem = [&](vi &elem, int i, int &c) {
            elem[i]--;
            if (elem[i] == 0) {
                c--;
            }
        };

        int l1 = 0;
        int l2 = 0;

        rep(i, l - 1) {
            add(elem1, fds[i], c1);
            add(elem2, fds[i], c2);
        }

        auto reorder1 = [&](int start, int lim) {
            while (l1 < start) {
                rem(elem1, fds[l1], c1);
                l1++;
            }

            while (c1 > k && l1 < lim) {
                rem(elem1, fds[l1], c1);
                l1++;
            }
        };

        auto reorder2 = [&](int start, int lim) {
            while (l2 < start) {
                rem(elem2, fds[l2], c2);
                l2++;
            }

            while (c2 >= k && l2 <= lim) {
                rem(elem2, fds[l2], c2);
                l2++;
            }
        };

        ll ans = 0;

        nrep(i, l - 1, n) {
            add(elem1, fds[i], c1);
            add(elem2, fds[i], c2);
            reorder1(i - r + 1, i - l + 1);
            reorder2(i - r + 1, i - l + 1);

            if (c1 != k) {
                continue;
            }

            ans += l2 - l1;
        }

        cout << ans << '\n';
    }
}
